Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be available on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1415142 - Broken downgrade path from nss-3.28.1-1.2 to nss-3.27.0-1.3
Summary: Broken downgrade path from nss-3.28.1-1.2 to nss-3.27.0-1.3
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: dnf
Version: 25
Hardware: Unspecified
OS: Unspecified
high
unspecified
Target Milestone: ---
Assignee: rpm-software-management
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-20 11:58 UTC by Martin Babinsky
Modified: 2017-02-17 11:14 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-02-17 11:14:16 UTC
Type: Bug


Attachments (Terms of Use)

Description Martin Babinsky 2017-01-20 11:58:15 UTC
Description of problem:

In an attempt to amend https://bugzilla.redhat.com/show_bug.cgi?id=1415140 an attempt was made do downgrade the library to the previous working version. However, this was not possible due to file ownership conflicts:

{{{
[root@master1 ~]# dnf clean all
234 files removed
[root@master1 ~]# dnf downgrade -y nss --allowerasing
Fedora 25 - x86_64                                                                   86 MB/s |  50 MB     00:00    
Fedora 25 - x86_64 - Updates                                                         85 MB/s |  16 MB     00:00    
Fedora 25 - Test Updates Source                                                      14 MB/s | 489 kB     00:00    
Fedora 25 - x86_64 - Test Updates                                                    84 MB/s | 7.1 MB     00:00    
Fedora 25 - x86_64 - Test Updates Debug                                              56 MB/s | 1.5 MB     00:00    
Failed to synchronize cache for repo 'group_freeipa-freeipa-master', disabling.
Dependencies resolved.
====================================================================================================================
 Package                        Arch               Version                        Repository                   Size
====================================================================================================================
Installing:
 glibc                          i686               2.24-4.fc25                    updates                     4.0 M
 libcrypt-nss                   i686               2.24-4.fc25                    updates                      43 k
 nspr                           i686               4.13.1-1.fc25                  fedora                      138 k
 nss                            i686               3.28.1-1.2.fc25                updates-testing             866 k
 nss-softokn                    i686               3.28.1-1.0.fc25                updates-testing             402 k
 nss-softokn-freebl             i686               3.28.1-1.0.fc25                updates-testing             215 k
 nss-util                       i686               3.28.1-1.0.fc25                updates-testing              82 k
 sqlite-libs                    i686               3.14.2-1.fc25                  fedora                      470 k
 zlib                           i686               1.2.8-10.fc24                  fedora                       98 k
Downgrading:
 nss                            x86_64             3.27.0-1.3.fc25                updates                     846 k
 nss-tools                      x86_64             3.27.0-1.3.fc25                updates                     498 k

Transaction Summary
====================================================================================================================
Install    9 Packages
Downgrade  2 Packages

Total download size: 7.6 M
Downloading Packages:
(1/11): nss-tools-3.27.0-1.3.fc25.x86_64.rpm                                         29 MB/s | 498 kB     00:00    
(2/11): nss-3.27.0-1.3.fc25.x86_64.rpm                                               35 MB/s | 846 kB     00:00    
(3/11): nss-3.28.1-1.2.fc25.i686.rpm                                                 30 MB/s | 866 kB     00:00    
(4/11): nspr-4.13.1-1.fc25.i686.rpm                                                  21 MB/s | 138 kB     00:00    
(5/11): zlib-1.2.8-10.fc24.i686.rpm                                                  12 MB/s |  98 kB     00:00    
(6/11): nss-softokn-3.28.1-1.0.fc25.i686.rpm                                         14 MB/s | 402 kB     00:00    
(7/11): glibc-2.24-4.fc25.i686.rpm                                                   63 MB/s | 4.0 MB     00:00    
(8/11): sqlite-libs-3.14.2-1.fc25.i686.rpm                                          9.7 MB/s | 470 kB     00:00    
(9/11): nss-softokn-freebl-3.28.1-1.0.fc25.i686.rpm                                 7.7 MB/s | 215 kB     00:00    
(10/11): libcrypt-nss-2.24-4.fc25.i686.rpm                                           15 MB/s |  43 kB     00:00    
(11/11): nss-util-3.28.1-1.0.fc25.i686.rpm                                           13 MB/s |  82 kB     00:00    
--------------------------------------------------------------------------------------------------------------------
Total                                                                               2.0 MB/s | 7.6 MB     00:03     
Running transaction check
Transaction check succeeded.
Running transaction test
The downloaded packages were saved in cache until the next successful transaction.
You can remove cached packages by executing 'dnf clean packages'.
Error: Transaction check error:
  file /usr/share/man/man5/cert8.db.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64
  file /usr/share/man/man5/cert9.db.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64
  file /usr/share/man/man5/key3.db.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64
  file /usr/share/man/man5/key4.db.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64
  file /usr/share/man/man5/pkcs11.txt.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64
  file /usr/share/man/man5/secmod.db.5.gz conflicts between attempted installs of nss-3.28.1-1.2.fc25.i686 and nss-3.27.0-1.3.fc25.x86_64

Error Summary
}}}

Version-Release number of selected component (if applicable):

See errors reported above.

How reproducible:


Steps to Reproduce:
1. update nss to nss-3.28.1-1.2
2. dnf clean all
3. dnf downgrade -y nss --allowerasing

Actual results:

downgrade fails due to file ownership conflicts.

Expected results:

nss is downgraded to previous versions along its' dependencies

Comment 1 Kai Engert (:kaie) (inactive account) 2017-01-20 13:06:24 UTC
Hubert found out it works if all required packages are given to dnf explicitly.

dnf downgrade nss-devel nss-util nss-util-devel nss-softokn nss-sysinit nss-softokn-freebl-devel nss nss-softokn-devel nss-tools nss-softokn-devel

dnf apparently doesn't figure it out automatically.

Comment 2 Igor Gnatenko 2017-01-20 13:17:31 UTC

*** This bug has been marked as a duplicate of bug 1326157 ***

Comment 3 Kai Engert (:kaie) (inactive account) 2017-01-20 13:34:29 UTC
Are you sure it's a duplicate? 

In the given scenario, *NO* i686 packages were installed. The downgrade attempted to install i686 packages with no apparent reason.

Comment 4 Igor Gnatenko 2017-01-20 13:37:17 UTC
(In reply to Kai Engert (:kaie) from comment #3)
> Are you sure it's a duplicate? 
> 
> In the given scenario, *NO* i686 packages were installed. The downgrade
> attempted to install i686 packages with no apparent reason.
hmm, right.

Actually it means that you don't have %{?_isa} somewhere in requires.

Please re-run with --debugsolver and attach debugdata directory.

Comment 5 Martin Babinsky 2017-01-30 17:19:39 UTC
Link to the (rather hefty) debugdata from the failed downgrade here:

https://mbabinsk.fedorapeople.org/f25_nss_dowgrade_debugdata.zip

Comment 6 Honza Silhan 2017-02-06 12:22:00 UTC
Can you please try that with DNF-2.0 in f26?

we should put ALLOW_DOWNGRADE flag to solver in command downgrade or when --allowerasing is set.

Comment 7 Jaroslav Mracek 2017-02-17 10:54:31 UTC
Please downgrade command was completely refactored (including added ALLOW_DOWNGRADE flag). Please can you try the latest version from rawhide (fc26) or from our testing repository (dnf copr enable rpmsoftwaremanagement/dnf-nightly) where are version for fc24+. 
Thanks a lot

Jaroslav

Comment 8 Jaroslav Mracek 2017-02-17 10:58:02 UTC
One additional information, please try to run downgrade command without --allowerasing option. Now it allows auto downgrade of dependencies and solver also prefers downgrade from package removal (without --allowerasing option it cannot remove any package).

Jaroslav

Comment 9 Jaroslav Mracek 2017-02-17 11:10:18 UTC
And I cannot reproduce it with following versions:

dnf-2.1.0-1.git.3.6c48a55.fc25.noarch
libsolv-0.6.25-1.fc25.x86_64
libdnf-0.7.3-1.fc25.x86_64

Probably the problem is already fixed as I mentioned above or I have a different system setup.

Comment 10 Igor Gnatenko 2017-02-17 11:14:16 UTC
(In reply to Jaroslav Mracek from comment #9)
> And I cannot reproduce it with following versions:
> 
> dnf-2.1.0-1.git.3.6c48a55.fc25.noarch
> libsolv-0.6.25-1.fc25.x86_64
> libdnf-0.7.3-1.fc25.x86_64
> 
> Probably the problem is already fixed as I mentioned above or I have a
> different system setup.

You definitely have different setup, but actually bug has been fixed.


Note You need to log in before you can comment on or make changes to this bug.